//+------------------------------------------------------------------+
//|                                  Phase Change Index Inverted.mq4 |
//|                                                       Akif TOKUZ |
//|                                             akifusenet@gmail.com |
//+------------------------------------------------------------------+
#property copyright "Akif TOKUZ"
#property link      "akifusenet@gmail.com"

#property indicator_separate_window

#property indicator_buffers 4
#property indicator_color1 White
#property indicator_width1 1
#property indicator_color2 Lime
#property indicator_width2 4
#property indicator_color3 Red
#property indicator_width3 4
#property indicator_color4 Orange
#property indicator_width4 2

#property indicator_level1 20
#property indicator_level2 80
#property indicator_level3 100
#property indicator_level4 0

//---- input parameters
extern int PeriodPCI=35;
//---- buffers
double PCI_Buffer[];
double Buy[];
double Sell[];
double Hold[];
double GradientLineBuffer[];
double UpDevBuffer[];
double DownDevBuffer[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   IndicatorBuffers(7);
   
   SetIndexBuffer(0,PCI_Buffer);   
   SetIndexStyle(0,DRAW_LINE);
   SetIndexLabel(0,"Phase Change Index");
   
   SetIndexBuffer(1,Buy);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexLabel(1,"Buy");
   
   SetIndexBuffer(2,Sell);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexLabel(2,"Sell");

   SetIndexBuffer(3,Hold);
   SetIndexStyle(3,DRAW_LINE);
   SetIndexLabel(3,"Hold");
   
   SetIndexBuffer(4,GradientLineBuffer);
   SetIndexBuffer(5,UpDevBuffer);
   SetIndexBuffer(6,DownDevBuffer);
   
   
   IndicatorShortName("PCI_Inverted"+"("+PeriodPCI+")");
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int startIndex;
   int limit,i;
   double momentum;
   int    counted_bars=IndicatorCounted();
//---- check for possible errors
   if(counted_bars<0) return(-1);
//---- last counted bar will be recounted
   if(counted_bars>0) limit=Bars-counted_bars;
   if (counted_bars==0) 
   {
      limit=Bars-PeriodPCI;
      for (i=Bars-1;i>limit;i--)
      {
         PCI_Buffer[i]=0.0;
      }      
   }

   for(i=limit; i>=0; i--)
   {
      startIndex=i+PeriodPCI-1;
      momentum=Close[i]-Close[startIndex];
      UpDevBuffer[i]=0;
      DownDevBuffer[i]=0;
      for(int k=0; k<PeriodPCI; k++)
      {
         GradientLineBuffer[startIndex-k]=Close[startIndex]+momentum*(PeriodPCI-1-k)/(PeriodPCI-1);         
         
         if (Close[startIndex-k]>GradientLineBuffer[startIndex-k])
         {
            UpDevBuffer[i]+=Close[startIndex-k]-GradientLineBuffer[startIndex-k];
         }
         else if (Close[startIndex-k]<GradientLineBuffer[startIndex-k])
         {
            DownDevBuffer[i]+=GradientLineBuffer[startIndex-k]-Close[startIndex-k];
         }
      }
      if ((UpDevBuffer[i]+DownDevBuffer[i])!=0)
      {
         PCI_Buffer[i]=(UpDevBuffer[i]/(UpDevBuffer[i]+DownDevBuffer[i]))*100;
         
         if ((momentum>0)&&(PCI_Buffer[i]<20))
         {
            Buy[i]=PCI_Buffer[i];
         }
         else if ((momentum<0)&&(PCI_Buffer[i]>80))
         {
            Sell[i]=PCI_Buffer[i];
         }
         else if  ( ((momentum>0)&&(PCI_Buffer[i]>80)) || ((momentum<0)&&(PCI_Buffer[i]<20)) )
         {
            Hold[i]=PCI_Buffer[i];
         }
         
      }
      
         
   }
      
   return(0);
  }
//+------------------------------------------------------------------+